LeetCode 162.寻找峰值

思路:

1.题目规定了nums-1 = numsn = -∞,也就是假设nums0的左边还有一个-∞,numsn - 1的右边还有一个-∞。原因在于这样可以保证数组一定有峰值。比如数组是严格递减的,那么nums0就是(唯一的)峰值;同理如果数组是严格递增的,那么numsn - 1就是(唯一的)峰值。

2.分析:如果i < n - 1且numsi < numsi + 1,那么在下标i + 1,n - 1中一定存在峰值(如果不满足,那么一定有numsi + 1 < numsi + 2,numsi + 2 < numsi + 3,...,numsn - 1 < numsn = -∞,可知不成立,因此在下标i + 1,n - 1中一定存在峰值)。同理可知如果i < n - 1且numsi > numsi + 1,那么在下标0,i中一定存在峰值。

3.因此,可以通过二分的方式,通过比较numsi和numsi + 1的大小关系,不断地缩小存在峰值的范围,二分找到峰值。

4.注意:如果有多个峰值,我们无法在一开始、以及二分过程中就确定哪个峰值最终会成为答案。二分的思路只是不断地缩小范围,并最终找到其中的一个峰值。由于每次只关注mid和mid + 1的局部大小关系,然后根据这个局部信息决定是向左还是向右。不同的数组初始状态会导致算法走向不同的峰值。因此得到的峰值不一定是全局最高峰。

5.复杂度分析:

(1)时间复杂度:O(logn),其中n为nums的长度。

(2)空间复杂度:O(1)。

附代码:

java 复制代码
class Solution {
    public int findPeakElement(int[] nums) {
        int left = 0;
        int right = nums.length - 1; // 闭区间[0,n - 1]
        
        while (left < right) { // 此时区间至少还有两个元素
            int mid = left + (right - left) / 2;
            if (nums[mid] > nums[mid + 1]) {
                // 下坡,峰顶位置 <= mid
                right = mid;
            } else {
                // 上坡,峰顶位置 >= mid + 1
                left = mid + 1;
            }
        }
        return left;
    }
}

ACM模式:

java 复制代码
import java.util.Scanner;

class Solution {
    public int findPeakElement(int[] nums) {
        int left = 0;
        int right = nums.length - 1; // 闭区间[0, n - 1]

        while (left < right) { // 此时区间至少还有两个元素
            int mid = left + (right - left) / 2;
            if (nums[mid] > nums[mid + 1]) {
                // 下坡,峰顶位置 <= mid
                right = mid;
            } else {
                // 上坡,峰顶位置 >= mid + 1
                left = mid + 1;
            }
        }
        return left;
    }
}

public class Main {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        // 读取数组长度
        int n = scanner.nextInt();

        // 读取数组元素
        int[] nums = new int[n];
        for (int i = 0; i < n; i++) {
            nums[i] = scanner.nextInt();
        }

        // 寻找峰值元素
        Solution solution = new Solution();
        int result = solution.findPeakElement(nums);
        System.out.println(result);

        scanner.close();
    }
}
相关推荐
zhangfeng11336 分钟前
qjlDim 含义 TurboQuant QJL Quantized Johnson-Lindenstrauss,量化JL随机投影
人工智能·算法·ai编程·npu
HwJack206 分钟前
【HarmonyOS开发小实践】HarmonyOS GC 引用计数 vs 对象追踪,三种回收算法
jvm·算法·harmonyos
blxr_9 分钟前
力扣hot100前k个高频元素https://leetcode.cn/problems/top-k-frequent-elements/
算法·leetcode·职场和发展
longlongzihan10 小时前
LeetCode 17电话号码的字母组合:回溯算法(DFS)详解
c++·算法·leetcode·深度优先
封印师请假去地球钓鱼10 小时前
边解边变的问题:从“决策依赖“一词出发
人工智能·算法
今晚打老虎11 小时前
c++之提高A(前缀和)(第三课)
数据结构·c++·算法
不会就选b12 小时前
算法日常・每日刷题--<贪心>26
数据结构·算法
hetao173383713 小时前
2026-09-29 hetao1733837 的刷题记录
c++·算法
欣欣之王来了14 小时前
AI合规专项:AI算法透明度的合规要求
人工智能·算法
wzdark14 小时前
分块思想在算法优化中的实践与应用4
算法